#ifndef DMEM_H
#define DMEM_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef DMEM
#   undef malloc
#   define malloc(x)        dmem_malloc(__FILE__,__LINE__,(x))
#   undef realloc
#   define realloc(x,y)     dmem_realloc(__FILE__,__LINE__,(x),(y))
#   undef calloc(x,y)
#   define calloc(x,y)      dmem_calloc(__FILE__,__LINE__,(x),(y))
#   undef free
#   define free(x)          dmem_free(__FILE__,__LINE__,(x))
#   undef strdup
#   define strdup(x)        dmem_strdup(__FILE__,__LINE__,(x))

#ifdef __cplusplus
extern "C" {
#endif

extern void *dmem_malloc(const char *fn,int l,size_t s);
extern void *dmem_calloc(const char *fn,int l,size_t n,size_t s);
extern void *dmem_realloc(const char *fn,int l,void *ptr,size_t s);
extern char *dmem_strdup(const char *fn,int l,const char *s);
extern void dmem_free(const char *fn,int l,void *ptr);

#ifdef __cplusplus
}
#endif

#endif  /* end of DMEM */
#endif  /* end of DMEM_H */
